/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the BillingAccountsList type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &BillingAccountsList{}

// BillingAccountsList struct for BillingAccountsList
type BillingAccountsList struct {
	Results []BillingAccount `json:"results"`
	Total int32 `json:"total"`
}

// NewBillingAccountsList instantiates a new BillingAccountsList object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewBillingAccountsList(results []BillingAccount, total int32) *BillingAccountsList {
	this := BillingAccountsList{}
	this.Results = results
	this.Total = total
	return &this
}

// NewBillingAccountsListWithDefaults instantiates a new BillingAccountsList object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewBillingAccountsListWithDefaults() *BillingAccountsList {
	this := BillingAccountsList{}
	return &this
}

// GetResults returns the Results field value
func (o *BillingAccountsList) GetResults() []BillingAccount {
	if o == nil {
		var ret []BillingAccount
		return ret
	}

	return o.Results
}

// GetResultsOk returns a tuple with the Results field value
// and a boolean to check if the value has been set.
func (o *BillingAccountsList) GetResultsOk() ([]BillingAccount, bool) {
	if o == nil {
		return nil, false
	}
	return o.Results, true
}

// SetResults sets field value
func (o *BillingAccountsList) SetResults(v []BillingAccount) {
	o.Results = v
}

// GetTotal returns the Total field value
func (o *BillingAccountsList) GetTotal() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Total
}

// GetTotalOk returns a tuple with the Total field value
// and a boolean to check if the value has been set.
func (o *BillingAccountsList) GetTotalOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Total, true
}

// SetTotal sets field value
func (o *BillingAccountsList) SetTotal(v int32) {
	o.Total = v
}

func (o BillingAccountsList) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o BillingAccountsList) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["results"] = o.Results
	toSerialize["total"] = o.Total
	return toSerialize, nil
}

type NullableBillingAccountsList struct {
	value *BillingAccountsList
	isSet bool
}

func (v NullableBillingAccountsList) Get() *BillingAccountsList {
	return v.value
}

func (v *NullableBillingAccountsList) Set(val *BillingAccountsList) {
	v.value = val
	v.isSet = true
}

func (v NullableBillingAccountsList) IsSet() bool {
	return v.isSet
}

func (v *NullableBillingAccountsList) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableBillingAccountsList(val *BillingAccountsList) *NullableBillingAccountsList {
	return &NullableBillingAccountsList{value: val, isSet: true}
}

func (v NullableBillingAccountsList) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableBillingAccountsList) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


